install_openssl:
  pkg.installed:
    - name: openssl

generate_csr:
  cmd.run:
    - name: openssl req -new -newkey rsa:2048 -nodes -keyout /"{{ salt['pillar.get']('private-key-path') }}" -out /"{{ salt['pillar.get']('csr-path') }}" -subj "/C={country}/ST={state}/L={place}/O="{{ salt['pillar.get']('organization-name') }}", LLC/CN="{{ salt['pillar.get']('common-name') }}""
    - unless: test -f {path of the csr}

send_csr_request:
  cmd.run:
    - name: |
        curl --location "{{ salt['pillar.get']('rest-api-url') }}" \
        --header 'x-api-key: "{{ salt['pillar.get']('x-api-key') }}"' \
        --header 'Content-Type: application/json' \
        --data "$(jq -n --arg csr "$(cat /"{{ salt['pillar.get']('csr-path') }}")" '{profile: {id: "{{ salt['pillar.get']('profile-id') }}"}, seat: {seat_id: "{custom-seat-id}"}, csr: $csr, attributes: {subject: {common_name: "{{ salt['pillar.get']('common-name') }}"}}')" >> /"{{ salt['pillar.get']('cert-path') }}"
        - cmd: generate_csr
